;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;
; SPI communication routines
;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

spi_init_basic	nop
		banksel	TRISA
		bsf	TRISB,D'004'		;SDI1 (RB4 -- input)  - MISO
		bcf	TRISC,D'007'		;SDO1 (RC7 -- output) - MOSI
		bcf	TRISB,D'006'		;SCK1 (RB6 -- output for master mode)

		bcf	TRISB,D'005'		;CS0 (RB5 -- output)

		clrf	BSR			;select BANK0
		bcf	PORTB,D'005'		;CS0 = 1 --- not active
		return
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;set up SPI BUS for communication as a master for MSSP1 in SPI Mode 0
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
spi_init_m0	call	spi_init_basic
		banksel	SSP1CON1
		movlw	B'00000010'		;see Datasheet Page 278
						;bit 7   = 0    -> N/A
						;bit 6   = 0    -> N/A
						;bit 5   = 1    -> enables MSSP2
						;CKP - bit 4   = 0    -> Idle state for clock is a low level
						;bit 3-0 = 0010 -> SPI Master mode, clock = FOSC/64
		movwf	SSP1CON1
;
		movlw	B'01000000'
		movwf	SSP1STAT		;bit 7   = 0 -> Input data sampled at middle of data output time
						;CKE - bit 6   = 1 -> Transmit occurs on transition from Active to Idle clock state
		bsf	SSP1CON1,D'005'		;enable SPI on MSSP1
		clrf	BSR
		return
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;set up SPI BUS for communication as a master for MSSP1 in SPI Mode 1
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
spi_init_m1	call	spi_init_basic
		banksel	SSP1CON1
		movlw	B'00000010'		;see Datasheet Page 278
						;bit 7   = 0    -> N/A
						;bit 6   = 0    -> N/A
						;bit 5   = 1    -> enables MSSP2
						;CKP - bit 4   = 0    -> Idle state for clock is a low level
						;bit 3-0 = 0010 -> SPI Master mode, clock = FOSC/64
		movwf	SSP1CON1
;
		movlw	B'00000000'
		movwf	SSP1STAT		;bit 7   = 0 -> Input data sampled at middle of data output time
						;CKE - bit 6   = 0 -> Transmit occurs on transition from Idle to Active clock state
		bsf	SSP1CON1,D'005'		;enable SPI on MSSP2
		clrf	BSR
		return

;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
spi_cs0_en	bsf	PORTB,D'005'		;CS0 = 0	;enabled
		return		
;--------------------------------------
spi_cs0_dis	bcf	PORTB,D'005'		;CS0 = 1	;disabled
		return		
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
spi_send	nop
		banksel	SSP1CON1
		bcf	SSP1CON1,SSPOV		;just for sure...
		bcf	SSP1STAT,BF

		movwf	SSP1BUF
spil2		btfss	SSP1STAT,BF
		goto	spil2
		movf	SSP1BUF,0
		clrf	BSR
		movwf	v_spi_buffi
		return
;-----------------------------------------------------------------------------
